//+--------------------------------------------------------------------------+
//| 																		 |
#define		Main_title		"AXP-AD02 Sample Program '98/07/02"
#define		Version			"V1.02"
//|			Cording date	1997/12/03										 |
//|			Up date			1998/07/02										 |
//| 																		 |
//|@@{vOTURBOC/BORANDCpłB								 |
//|@@{vOgpꍇTURBOC/BORANDCt̃OtBbNhCo  |
//|@@KvłB															 |
//+--------------------------------------------------------------------------+
#include <graphics.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <alloc.h>
#include <stdarg.h>
#include <ctype.h>
#include "ad02lib.h"

//----- ̕\ް̒` -----
#define	LEFT		1			//̕\͈
#define	TOP			1			//@@h@@@
#define	RIGHT		637			//@@h@@@
#define	BOTTOM		300			//@@h@@@
#define	SAMPLENUM	(RIGHT - LEFT)
#define	SAMPLESIZE	(SAMPLENUM * MAXCH)
#define	GMIN		0x0			//\ް̍ŏl
#define	GMAX		0xfff		//\ް̍ől
#define	XWAIT	((RIGHT - LEFT) / SAMPLENUM)	//X1ޯĂ̕
#define	YWAIT	((float)(GMAX - GMIN) / (float)(BOTTOM - TOP))	//Y1ޯĂ̏d

static int gCardHd;
//+==========================================================================+
//|						̕\֐									 |
//+==========================================================================+
static int GraphDriver;		/* The Graphics device driver		*/
static int GraphMode;		/* The Graphics mode value		*/

//----- ̨̏ -----
static int OpenGraph(void)
{
int ErrorCode;

	GraphDriver = DETECT; 			/* Request auto-detection	*/
	initgraph( &GraphDriver, &GraphMode, "" );
	ErrorCode = graphresult();		/* Read result of initialization*/
	if( ErrorCode != grOk ){		/* Error occured during init	*/
		printf("\nGraphics System Error: %s\n", grapherrormsg( ErrorCode ) );
		return(-1);
	}

	graphresult();					/* clear error code		*/
	settextstyle(DEFAULT_FONT,HORIZ_DIR,1);
	ErrorCode = graphresult();		/* check result 		*/
	if( ErrorCode != grOk ){		/* if error occured		*/
		closegraph();
		printf("\nGraphics System Error: %s\n", grapherrormsg( ErrorCode ) );
		return(-1);
	}
	settextjustify( LEFT_TEXT, TOP_TEXT );
	return(0);
}
//----- \֐ -----
static int gprintf( int *xloc, int *yloc, char *fmt, ... )
{
va_list	argptr;				/* Argument list pointer	*/
char	str[140];			/* Buffer to build sting into	*/
int		cnt;				/* Result of SPRINTF for return */

	va_start( argptr, fmt );			/* Initialize va_ functions	*/
	cnt = vsprintf( str, fmt, argptr );	/* prints string to buffer	*/
	outtextxy( *xloc, *yloc, str );		/* Send string in graphics mode */
	*yloc += textheight( "H" ) + 2;		/* Advance to next line         */
	*xloc += textwidth(str);
	va_end( argptr );					/* Close va_ functions		*/
	return( cnt );						/* Return the conversion count	*/
}
//+==========================================================================+
//|																		 |
//+==========================================================================+
static int gIntTime = 10;		//݂̻ݸގ
static int gNextRange = 0;		//݂̻ݸݼ
static int DispCh[MAXCH] = { 1,1,1,1,1,1,1,1 };	//݂̕\̗L

static int KeyCheck(void)
{
int		key=0;

	if (kbhit()){
		key = getch();
		switch(toupper(key)){
			case 'S' :	if (255 > gIntTime)
							gIntTime++;
						break;
			case 'F' :	if (1 < gIntTime)
							--gIntTime;
						break;
			case 'L' :	gNextRange = 1; break;
			case 'H' :	gNextRange = 0; break;
			case '1' :
			case '2' :
			case '3' :
			case '4' :
			case '5' :
			case '6' :
			case '7' :
			case '8' :	DispCh[key-'1'] = (0 == DispCh[key-'1']) ? 1 : 0;
						break;
		}
	}
	return(key);
}
//+==========================================================================+
//|						TYPE/ݼޏ										 |
//+==========================================================================+
static int	gRange = -1;

//----- ݼޕύX -----
static int ChgRange(int Range)
{
	if (gRange != Range){
		AD02_cal_prset(Range,gCardHd);
		gRange = Range;
	}
	return(gRange);
}
//----- ݸޏI҂ -----
static int WaitEoc(void)
{
int		key=0;

	while(SAMPLE_END != AD02_eoc(gCardHd)){		//ݸޏI҂
		if ('\x1b' == (key = KeyCheck()))
			break;
	}
	return(key);
}
//+==========================================================================+
//|						ް\										 |
//+==========================================================================+

//----- ̂̕\g` -----
//@ݒ肳ꂽ̂̍Wʒuɸ̂̊Og`
static void PutGraphBox(void)
{
int		x,y,w,h;

	setcolor(WHITE);								// Fݒ肵
	setlinestyle(SOLID_LINE,0,NORM_WIDTH);			//ɰײݐݒ
	x = LEFT - 1;					//̊Og̍W߂
	y = TOP - 1;
	w = LEFT + (RIGHT - LEFT + 2);
	h = BOTTOM + 2;
	setcolor(WHITE);				//̊Og`
	setlinestyle(SOLID_LINE,0,NORM_WIDTH);
	line(x,y,x,h);
	line(x,y,w,y);
	line(x,h,w,h);
	line(w,h,w,y);
}

//	eق̶װ`
int Color[MAXCH] = { BROWN,RED,CYAN,YELLOW,GREEN,BLUE,MAGENTA,LIGHTGRAY };
//	O̕\߲
typedef struct {
	int		x;
	int		y;
} XY;

static int DispSample(unsigned short *Buff)
{
int		key,Ch,Num,Xp,Yp,SampleNum;
unsigned short 	Dat;
XY		Bef[MAXCH];
int		Disp[MAXCH];

	cleardevice();
	PutGraphBox();
	Xp = 1; Yp = BOTTOM+30;
	gprintf(&Xp,&Yp,"Select Ch:");
	for (Ch=0; Ch < MAXCH; Ch++){
		if (0 != DispCh[Ch]){
			Yp = BOTTOM+30;
			setcolor(Color[Ch]);
			gprintf(&Xp,&Yp," %d",Ch+1);
		}
		Disp[Ch] = DispCh[Ch];
	}
	setcolor(WHITE);
	Xp=1;
	gprintf(&Xp,&Yp,"Range : %+3.1fV - %+3.1fV"
					,(0 == gRange) ? -10.0 : -5.0
					,(0 == gRange) ? +10.0 : +5.0
	);
	Xp=1;
	gprintf(&Xp,&Yp,"Time  : %lduS",(long)gIntTime * 10L * SAMPLESIZE);

	for (Num=0; Num < SAMPLENUM; Num++){
		do {
			key = KeyCheck();
			if ('\x1b' == key)
				goto quit;
			AD02_loc(&SampleNum,gCardHd);
		} while(SampleNum < ((Num + 1) * MAXCH));
		for (Ch=0; Ch < MAXCH; Ch++){
			Dat = Buff[Num * MAXCH + Ch];
			if (0 != Disp[Ch]){
				setcolor(Color[Ch]);						// Fݒ肵
				Xp = LEFT + Num * XWAIT;				//numڂXW擾
				if (Dat <= GMIN)							//\͈͂̍ŏlȉȂ
					Yp = BOTTOM;
				else if (Dat >= GMAX)						//\͈͂̍őlȏȂ
					Yp = TOP;
				else										//͈͓Ȃ
					Yp = BOTTOM - (int)((Dat - GMIN) / YWAIT);
				if (0 != Num)								//OްLH
					line(Bef[Ch].x,Bef[Ch].y,Xp,Yp);					//ʏʂ
				Bef[Ch].y = Yp;
				Bef[Ch].x = Xp;
			}
		}
	}
quit:
	return(key);
}
//+==========================================================================+
//|						C											 |
//+==========================================================================+
#define	BUFFNUM	2
static unsigned short far *gBuff =  NULL;

//----- ݒ -----
static int Initial(void)
{
	if (0 != OpenGraph())
		goto err;
	gBuff = (unsigned short far *)malloc(SAMPLESIZE * sizeof(unsigned short) + 10);
	if (NULL == gBuff){
		printf("\nذ܂");
		goto err;
	}
	if (SUCCESS != AD02_init(&gCardHd)){
		printf("\nAXP-AD02ݒװ");
		goto err;
	}
	return(0);
err:
	return(-1);
}
//----- I -----
static void Close(void)
{
	Sample_stop(gCardHd);
	AD02_close(gCardHd);
	closegraph(); 				/* Return the system to text mode	*/
	if (NULL != gBuff)
		free(gBuff);
}
//----- Ҳ -----
void main( void )
{
long	bef;

	bef = coreleft();			// for check heap memory
	printf("\n%s  %s",Main_title,Version);
	if (0 == Initial()){
		while(1){
			ChgRange(gNextRange);
			AD02_mode(gRange,0,MAXCH-1,gIntTime,gCardHd);
			Sample_start(0,gBuff,SAMPLESIZE,gCardHd);
			if ('\x1b' == DispSample(gBuff))
				break;
			if ('\x1b' == WaitEoc())
				break;
			Sample_stop(gCardHd);
		}
	}
	Close();
	if (bef != coreleft()) {
		printf("\n\x7 Heap %lx-%lx=%lx\r\n",bef,coreleft(),bef-coreleft());
	}
}
