/*============================================================================
//	Axpad02w.cs
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//==========================================================================*/
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Runtime.InteropServices;

namespace SampleAd02
{
	/// <summary>
	/// Axpad02w ̊Tv̐łB
	/// </summary>
	public class Axpad02w
	{
		private int mErrWradll = SUCCESS;	// bp[֐G[

		public const short	SOCKET_AUTO				= -1;
		public const int	MAX_SOCKETS				= 4;
		public const int	NUM_CHANNELS			= 8;
		//-------------------------------------------------------------------
		// dW
		//-------------------------------------------------------------------
		public const int	VR_S10V					= 0;	// +-10V range
		public const int	VR_S5V					= 1;	// +- 5V range
		//-------------------------------------------------------------------
		// gK
		//-------------------------------------------------------------------
		public const int	TS_INTERNAL				= 0;	// gKgp
		public const int	TS_EXTERNAL				= 1;	// OgKgp
		//-------------------------------------------------------------------
		// TvO
		//-------------------------------------------------------------------
		public const int	SM_ONESHOT				= 0;	// Vbg
		public const int	SM_CONTINUOUS			= 1;	// ATvO
		//-------------------------------------------------------------------
		// TvOXe[^X̃rbg}XN
		//-------------------------------------------------------------------
		public const int	BMSST_BUSY				= (1 <<  0);	// Busy
		public const int	BMSST_EOC				= (1 <<  1);	// Not busy
		public const int	BMSST_HALF_FULL			= (1 <<  2);	// Ring buffer half full
		public const int	BMSST_OVERFLOW			= (1 <<  3);	// Ring buffer overflow
		public const int	BMSST_OVERRUN			= (1 <<  4);	// FIFO overrun
		//-------------------------------------------------------------------
		// AvP[Vɑ郁bZ[W
		// ̒l uWMBase𑫂l𑗏o܂
		//-------------------------------------------------------------------
		public const int	WM_OFS_CARD_REMOVAL		= 0;
		public const int	WM_OFS_EOC				= 1;
		public const int	WM_OFS_HALF_FULL		= 2;
		public const int	WM_OFS_OVERFLOW			= 3;
		public const int	WM_OFS_OVERRUN			= 4;
		public const int	WM_OFS_EXIN				= 5;
		//-------------------------------------------------------------------
		// 샂[h\
		//-------------------------------------------------------------------
		[StructLayout(LayoutKind.Sequential)]
		public struct Mode
		{
			public int	dwVoltageRange;		// dW
			public int	dwChFirst;			// Jn`l
			public int	dwChLast;			// ŏI`l
			public int	dwTimer;			// ^C}
			public int	dwTrigSource;		// gK\[X
			public int	dwSampleMode;		// TvO[h
			public int	cwBuffer;			// obt@TCY
		};
		//-------------------------------------------------------------------
		// \[X\
		//-------------------------------------------------------------------
		public const int	MAX_MEM					= 9;
		public const int	MAX_IO					= 20;
		public const int	MAX_IRQ					= 7;
		public const int	MAX_DMA					= 7;
		public const int	MAX_RSV					= 3;

		[StructLayout(LayoutKind.Sequential)]
		public struct Resource
		{
			public int		dwNumMemWindows;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_MEM)]
			public int[]	dwMemBase;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_MEM)]
			public int[]	dwMemLength;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_MEM)]
			public int[]	dwMemAttrib;
			public int		dwNumIOPorts;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_IO)]
			public int[]	dwIOPortBase;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_IO)]
			public int[]	dwIOPortLength;
			public int		dwNumIRQs;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_IRQ)]
			public int[]	dwIRQRegisters;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_IRQ)]
			public int[]	dwIRQAttrib;
			public int		dwNumDMAs;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_DMA)]
			public int[]	dwDMALst;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_DMA)]
			public int[]	dwDMAAttrib;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_RSV)]
			public int[]	dwReserved1;
		}
		//-------------------------------------------------------------------
		// G[R[h
		//-------------------------------------------------------------------
		public const int	SUCCESS					= 0;	// ُȂiIj
		public const int	ERR_SYSTEM				= 1;	// ɃhCo[hĂȂ\܂
		public const int	ERR_NO_DEVICE			= 2;	// gp\ȃfoCX܂
		public const int	ERR_NOT_CREATED			= 3;	// w̃foCX͎gp錾Ă܂
		public const int	ERR_IN_USE				= 4;	// w̃foCX͑̃vZXŎgpł
		public const int	ERR_INVALID_SOCKET		= 5;	// Ș_\Pbgԍł
		public const int	ERR_RESOURCE			= 6;	// \[XG[
		public const int	ERR_INVALID_ARGUMENT	= 7;	// sȈw肵܂
		public const int	ERR_VOLTAGE_RANGE		= 8;	// sȓdlw肵܂
		public const int	ERR_CHANNEL				= 9;	// sȃ`lw肵܂
		public const int	ERR_TIMER				= 10;	// sȃ^C}w肵܂
		public const int	ERR_TRIG_SOURCE			= 11;	// sȃgKw肵܂
		public const int	ERR_SAMPLE_MODE			= 12;	// sȃ[hw肵܂
		public const int	ERR_NOT_ENOUGH_MEM		= 13;	// w肳ꂽobt@mۂł܂ł
		public const int	ERR_NO_DATA				= 14;	// f[^v܂
		public const int	ERR_NO_DLL				= 15;	// ckkɃ[h܂ł
		public const int	ERR_NO_SETMODE			= 20;	// [hݒ肳Ă܂ł
		public const int	ERR_BUSY				= 21;	// TvO쒆ł
		public const int	ERR_WRAPDLL				= -1;	// bp[֐G[
		//-------------------------------------------------------------------
		// API
		//-------------------------------------------------------------------
		[DllImport("axpad02.dll")]
		public extern static unsafe bool Ad02GetVersion ( int* pdwDllVer, int* pdwDrvVer );
		[DllImport("axpad02.dll")]
		public extern static unsafe bool Ad02Create( short* pwLogSocket, int hWnd, short uWMBase, int* pvInitArg );
		[DllImport("axpad02.dll")]
		public extern static        bool Ad02Close ( short wLogSocket );
		[DllImport("axpad02.dll")]
		public extern static        bool Ad02GetResource ( short wLogSocket, ref Resource pResInfo );
		[DllImport("axpad02.dll")]
		public extern static        bool Ad02SetMode ( short wLogSocket, ref Mode pmode );
		[DllImport("axpad02.dll")]
		public extern static        bool Ad02StartSampling ( short wLogSocket );
		[DllImport("axpad02.dll")]
		public extern static        bool Ad02StopSampling ( short wLogSocket );
		[DllImport("axpad02.dll")]
		public extern static unsafe bool Ad02GetSamplingStatus ( short wLogSocket, int* pcwData, int* pdwStatus );
		[DllImport("axpad02.dll")]
		public extern static unsafe bool Ad02GetData ( short wLogSocket, short* pwData, int cwData );
		[DllImport("axpad02.dll")]
		public extern static        bool Ad02OutPort ( short wLogSocket, Byte bValue );
		[DllImport("axpad02.dll")]
		public extern static unsafe bool Ad02InPort ( short wLogSocket, Byte* pbValue );
		[DllImport("axpad02.dll")]
		public extern static unsafe bool Ad02SingleSampling( short wLogSocket, int dwCh, int dwVoltageRange, short* pwData );
		[DllImport("axpad02.dll")]
		public extern static        int  Ad02GetLastError ( short wLogSocket ); 

		public Axpad02w()
		{
			// 
			// TODO: RXgN^ WbNɒǉĂB
			//
		}

		/*****************************************************************************
		* @\  AXP-AD02DLL,Driver̃o[Wԍ擾
		* 	 pdwDllVer --- DLLo[Wԍi[AhX
		*		 pdwDrvVer --- Drivero[Wԍi[AhX
		* ߒl	 true	   --- 
		*		 false	   --- s
		*****************************************************************************/
		public unsafe bool GetVersion ( int* pdwDllVer, int* pdwDrvVer )
		{
			try {
				return Ad02GetVersion(pdwDllVer, pdwDrvVer);
			}
			catch (Exception e) {
				MessageBox.Show(e.Message, "AXP-AD02 ERROR",
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;	// bp[֐G[
				return false;
			}
		}

		/*****************************************************************************
		 * @\  AXP-AD02̔Cӂ̃foCX̎gp錾
		 * 	 pwLogSocket	--- gpfoCXi[AhX
		 *       hWnd       --- bZ[W󂯂EChEnh
		 *       uWMBase    --- bZ[Whc̃x[X
		 *       pvInitArg  --- \
		 * ߒl	 true		--- 
		 *		 false		--- s
		 *****************************************************************************/
		public unsafe bool Create ( short* pwLogSocket, int hWnd, short uWMBase, int* pvInitArg )
		{
			try {
				return Ad02Create(pwLogSocket, hWnd, uWMBase, pvInitArg);
			}
			catch (Exception e) {
				MessageBox.Show(e.Message, "AXP-AD02 ERROR",
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;	// bp[֐G[
				return false;
			}
		}

		/*****************************************************************************
		 * @\  AXP-AD02̔Cӂ̃foCX̎gpJ
		 * 	 wLogSocket  --- gpfoCX
		 * ߒl	 true	   --- 
		 *		 false	   --- s
		 *****************************************************************************/
		public bool Close ( short wLogSocket )
		{
			try {
				return Ad02Close(wLogSocket);
			}
			catch (Exception e) {
				MessageBox.Show(e.Message, "AXP-AD02 ERROR",
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;	// bp[֐G[
				return false;
			}
		}

		/*****************************************************************************
		 * @\  wfoCX̃\[X擾
		 * 	 wLogSocket --- ׂfoCX
		 *		 pResInfo --- \[Xi[\̂̃AhX
		 * ߒl	 true	  --- 
		 *		 false	  --- s
		 *****************************************************************************/
		public bool GetResource ( short wLogSocket, ref Resource pResInfo )
		{
			try {
				return Ad02GetResource(wLogSocket, ref pResInfo);
			}
			catch (Exception e) {
				MessageBox.Show(e.Message, "AXP-AD02 ERROR",
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;	// bp[֐G[
				return false;
			}
		}

		/*****************************************************************************
		 * @\  TvO샂[hݒ
		 * 	 wLogSocket --- foCX
		 *		 pmode      --- [hݒf[^
		 * ߒl	 true	    --- 
		 *		 false	    --- s
		 *****************************************************************************/
		public bool SetMode ( short wLogSocket, ref Mode pmode )
		{
			try {
				return Ad02SetMode(wLogSocket, ref pmode);
			}
			catch (Exception e) {
				MessageBox.Show(e.Message, "AXP-AD02 ERROR",
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;	// bp[֐G[
				return false;
			}
		}

		/*****************************************************************************
		 * @\  TvOJn
		 * 	 wLogSocket --- foCX
		 * ߒl	 true	    --- 
		 *		 false	    --- s
		 *****************************************************************************/
		public bool StartSampling ( short wLogSocket )
		{
			try {
				return Ad02StartSampling(wLogSocket);
			}
			catch (Exception e) {
				MessageBox.Show(e.Message, "AXP-AD02 ERROR",
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;	// bp[֐G[
				return false;
			}
		}

		/*****************************************************************************
		 * @\  TvO~
		 * 	 wLogSocket --- foCX
		 * ߒl	 true	    --- 
		 *		 false	    --- s
		 *****************************************************************************/
		public bool StopSampling ( short wLogSocket )
		{
			try {
				return Ad02StopSampling(wLogSocket);
			}
			catch (Exception e) {
				MessageBox.Show(e.Message, "AXP-AD02 ERROR",
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;	// bp[֐G[
				return false;
			}
		}

		/*****************************************************************************
		 * @\  TvOԂ̎擾
		 * 	 wLogSocket --- foCX
		 *       pcwData    --- TvOς݃f[^i[̈ւ̃|C^
		 *       pdwStatus  --- TvOXe[^Xi[̈ւ̃|C^
		 * ߒl	 true	    --- 
		 *		 false	    --- s
		 *****************************************************************************/
		public unsafe bool GetSamplingStatus ( short wLogSocket, int* pcwData, int* pdwStatus )
		{
			try {
				return Ad02GetSamplingStatus(wLogSocket,pcwData,pdwStatus);
			}
			catch (Exception e) {
				MessageBox.Show(e.Message, "AXP-AD02 ERROR",
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;	// bp[֐G[
				return false;
			}
		}

		/*****************************************************************************
		 * @\  TvOς݃f[^̎擾
		 * 	 wLogSocket --- foCX
		 *       pwData     --- TvOς݃f[^i[̈ւ̃|C^
		 *       cwData     --- ǂݏof[^
		 * ߒl	 true	    --- 
		 *		 false	    --- s
		 *****************************************************************************/
		public unsafe bool GetData ( short wLogSocket, short* pwData, int cwData )
		{
			try {
				return Ad02GetData(wLogSocket,pwData,cwData);
			}
			catch (Exception e) {
				MessageBox.Show(e.Message, "AXP-AD02 ERROR",
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;	// bp[֐G[
				return false;
			}
		}

		/*****************************************************************************
		 * @\  ėpo̓|[gɒlo
		 * 	 wLogSocket --- foCX
		 *       bValue     --- o͂l
		 * ߒl	 true	    --- 
		 *		 false	    --- s
		 *****************************************************************************/
		public bool OutPort ( short wLogSocket, Byte bValue )
		{
			try {
				return Ad02OutPort(wLogSocket,bValue);
			}
			catch (Exception e) {
				MessageBox.Show(e.Message, "AXP-AD02 ERROR",
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;	// bp[֐G[
				return false;
			}
		}

		/*****************************************************************************
		 * @\  ėp̓|[g̒l擾
		 * 	 wLogSocket --- foCX
		 *       pbValue    --- 擾li[̈̃|C^
		 * ߒl	 true	    --- 
		 *		 false	    --- s
		 *****************************************************************************/
		public unsafe bool InPort ( short wLogSocket, Byte* pbValue )
		{
			try {
				return Ad02InPort(wLogSocket,pbValue);
			}
			catch (Exception e) {
				MessageBox.Show(e.Message, "AXP-AD02 ERROR",
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;	// bp[֐G[
				return false;
			}
		}

		/*****************************************************************************
		 * @\  ėp̓|[g̒l擾
		 * 	 wLogSocket --- foCX
		 *       pbValue    --- 擾li[̈̃|C^
		 * ߒl	 true	    --- 
		 *		 false	    --- s
		 *****************************************************************************/
		public unsafe bool SingleSampling( short wLogSocket, int dwCh, int dwVoltageRange, short* pwData )
		{
			try {
				return Ad02SingleSampling(wLogSocket,dwCh,dwVoltageRange,pwData);
			}
			catch (Exception e) {
				MessageBox.Show(e.Message, "AXP-AD02 ERROR",
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;	// bp[֐G[
				return false;
			}
		}

		/*****************************************************************************
		 * @\  G[R[h擾
		 * 	 wLogSocket --- ΏۃfoCX
		 * ߒl	 G[R[h
		 *****************************************************************************/
		public int GetLastError( short wLogSocket )
		{
			try {
				if (mErrWradll == ERR_WRAPDLL) {	// bp[֐G[Ȃ
					mErrWradll = SUCCESS;			// NA
					return ERR_WRAPDLL;
				} else {
					return Ad02GetLastError(wLogSocket);
				}
			}
			catch (Exception e) {
				MessageBox.Show(e.Message, "AXP-AD02 ERROR",
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = SUCCESS;	// bp[֐G[
				return ERR_WRAPDLL;
			}
		}
	}
}
