'****************************************************************************
'*  axpad02w.vb
'*
'*  Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
'*
'****************************************************************************
Option Strict Off
Option Explicit On 

Imports System
Imports System.Runtime.InteropServices

Public Class Axpad02w

    Private mErrWradll As Integer = SUCCESS   ' bp[֐G[

    '-----------------------------------------------------------------
    ' G[R[h
    '-----------------------------------------------------------------
    Public Const SUCCESS As Integer = 0                 ' ُȂiIj
    Public Const ERR_SYSTEM As Integer = 1              ' ɃhCo[hĂȂ\܂
    Public Const ERR_NO_DEVICE As Integer = 2           ' gp\ȃfoCX܂
    Public Const ERR_NOT_CREATED As Integer = 3         ' w̃foCX͎gp錾Ă܂
    Public Const ERR_IN_USE As Integer = 4              ' w̃foCX͑̃vZXŎgpł
    Public Const ERR_INVALID_SOCKET As Integer = 5      ' Ș_\Pbgԍł
    Public Const ERR_RESOURCE As Integer = 6            ' \[XG[
    Public Const ERR_INVALID_ARGUMENT As Integer = 7    ' sȈw肵܂
    Public Const ERR_VOLTAGE_RANGE As Integer = 8       ' sȓdlw肵܂
    Public Const ERR_CHANNEL As Integer = 9             ' sȃ`lw肵܂
    Public Const ERR_TIMER As Integer = 10              ' sȃ^C}w肵܂
    Public Const ERR_TRIG_SOURCE As Integer = 11        ' sȃgKw肵܂
    Public Const ERR_SAMPLE_MODE As Integer = 12        ' sȃ[hw肵܂
    Public Const ERR_NOT_ENOUGH_MEM As Integer = 13     ' w肳ꂽobt@mۂł܂ł
    Public Const ERR_NO_DATA As Integer = 14            ' f[^v܂
    Public Const ERR_NO_SETMODE As Integer = 20         ' [hݒ肳Ă܂ł
    Public Const ERR_BUSY As Integer = 21               ' TvO쒆ł
    Public Const ERR_WRAPDLL As Integer = -1            ' bp[֐G[
    '-----------------------------------------------------------------
    ' ̑̒萔
    '-----------------------------------------------------------------
    Public Const SOCKET_AUTO As Short= &HFFFFS
    Public Const MAX_SOCKETS As Integer = 4             ' foCX͂S܂Ŏg܂
    Public Const NUM_CHANNELS As Integer = 8
    '-----------------------------------------------------------------
    ' dW
    '-----------------------------------------------------------------
    Public Const VR_S10V As Integer = 0                 ' +-10V range
    Public Const VR_S5V As Integer = 1                  ' +- 5V range
    '-----------------------------------------------------------------
    ' gK
    '-----------------------------------------------------------------
    Public Const TS_INTERNAL As Integer = 0             ' gKgp
    Public Const TS_EXTERNAL As Integer = 1             ' OgKgp
    '-----------------------------------------------------------------
    ' TvO
    '-----------------------------------------------------------------
    Public Const SM_ONESHOT As Integer = 0              ' Vbg
    Public Const SM_CONTINUOUS As Integer = 1           ' ATvO
    '-----------------------------------------------------------------
    ' TvOXe[^X̃rbg}XN
    '-----------------------------------------------------------------
    Public Const BMSST_BUSY As Integer = &H1            ' Busy
    Public Const BMSST_EOC As Integer = &H2             ' Not busy
    Public Const BMSST_HALF_FULL As Integer = &H4       ' Ring buffer half full
    Public Const BMSST_OVERFLOW As Integer = &H8        ' Ring buffer overflow
    Public Const BMSST_OVERRUN As Integer = &H10        ' FIFO overrun
    '-----------------------------------------------------------------
    ' hCo瑗Ă郁bZ[W
    ' ̒l uWMBase𑫂lĂ܂
    '-----------------------------------------------------------------
    Public Const WM_OFS_CARD_REMOVAL As Integer = 0
    Public Const WM_OFS_EOC As Integer = 1
    Public Const WM_OFS_HALF_FULL As Integer = 2
    Public Const WM_OFS_OVERFLOW As Integer = 3
    Public Const WM_OFS_OVERRUN As Integer = 4
    Public Const WM_OFS_EXIN As Integer = 5
    '-----------------------------------------------------------------
    ' \[X\̊evf̍ő吔
    '-----------------------------------------------------------------
    Public Const MIN_NUM As Integer = 0
    Public Const MAX_MEM As Integer = 9 - 1    ' MAX_MEM_REGISTERS
    Public Const MAX_IO As Integer = 20 - 1    ' MAX_IO_PORTS
    Public Const MAX_IRQ As Integer = 7 - 1    ' MAX_IRQS
    Public Const MAX_DMA As Integer = 7 - 1    ' MAX_DMA_CHANNELS
    Public Const MAX_RSV As Integer = 3 - 1

    Structure Resource
        Dim dwNumMemWindows As Integer
        <VBFixedArray(MAX_MEM), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_MEM + 1)> Dim dwMemBase() As Integer
        <VBFixedArray(MAX_MEM), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_MEM + 1)> Dim dwMemLength() As Integer
        <VBFixedArray(MAX_MEM), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_MEM + 1)> Dim dwMemAttrib() As Integer
        Dim dwNumIOPorts As Integer
        <VBFixedArray(MAX_IO), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_IO + 1)> Dim dwIOPortBase() As Integer
        <VBFixedArray(MAX_IO), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_IO + 1)> Dim dwIOPortLength() As Integer
        Dim dwNumIRQs As Integer
        <VBFixedArray(MAX_IRQ), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_IRQ + 1)> Dim dwIRQRegisters() As Integer
        <VBFixedArray(MAX_IRQ), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_IRQ + 1)> Dim dwIRQAttrib() As Integer
        Dim dwNumDMAs As Integer
        <VBFixedArray(MAX_DMA), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_DMA + 1)> Dim dwDMALst() As Integer
        <VBFixedArray(MAX_DMA), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_DMA + 1)> Dim dwDMAAttrib() As Integer
        <VBFixedArray(MAX_RSV), MarshalAs(UnmanagedType.ByValArray, _
            SizeConst:=MAX_RSV + 1)> Dim dwReserved1() As Integer
    End Structure

    '-----------------------------------------------------------------
    ' 샂[hݒ\
    '-----------------------------------------------------------------
    Structure Mode
        Dim dwVoltageRange As Integer                      ' dW
        Dim dwChFirst As Integer                           ' Jn`l
        Dim dwChLast As Integer                            ' ŏI`l
        Dim dwTimer As Integer                             ' ^C}
        Dim dwTrigSource As Integer                        ' gK\[X
        Dim dwSampleMode As Integer                        ' TvO[h
        Dim cwBuffer As Integer                            ' obt@TCY
    End Structure

    '-----------------------------------------------------------------
    ' API Functions
    '-----------------------------------------------------------------
    <DllImport("axpad02.dll")> _
    Public Shared Function Ad02GetVersion(ByRef pdwDllVer As Integer, ByRef pdwDrvVer As Integer) As Boolean
    End Function
    <DllImport("axpad02.dll")> _
    Public Shared Function Ad02Create(ByRef pwLogSocket As Short, ByVal hWnd As Integer, ByVal uWMBase As Short, ByRef pvInitArg As Integer) As Boolean
    End Function
    <DllImport("axpad02.dll")> _
    Public Shared Function Ad02Close(ByVal wLogSocket As Short) As Boolean
    End Function
    <DllImport("axpad02.dll")> _
    Public Shared Function Ad02GetResource(ByVal wLogSocket As Short, ByRef pres As Resource) As Boolean
    End Function
    <DllImport("axpad02.dll")> _
    Public Shared Function Ad02SetMode(ByVal wLogSocket As Short, ByRef pmode As Mode) As Boolean
    End Function
    <DllImport("axpad02.dll")> _
    Public Shared Function Ad02StartSampling(ByVal wLogSocket As Short) As Boolean
    End Function
    <DllImport("axpad02.dll")> _
    Public Shared Function Ad02StopSampling(ByVal wLogSocket As Short) As Boolean
    End Function
    <DllImport("axpad02.dll")> _
    Public Shared Function Ad02GetSamplingStatus(ByVal wLogSocket As Short, ByRef pcwData As Integer, ByRef pdwStatus As Integer) As Boolean
    End Function
    <DllImport("axpad02.dll")> _
    Public Shared Function Ad02GetData(ByVal wLogSocket As Short, ByRef pwData As Short, ByVal cwData As Integer) As Boolean
    End Function
    <DllImport("axpad02.dll")> _
    Public Shared Function Ad02GetLastError(ByVal wLogSocket As Short) As Integer
    End Function
    <DllImport("axpad02.dll")> _
    Public Shared Function Ad02InPort(ByVal wLogSocket As Short, ByRef pbValue As Byte) As Boolean
    End Function
    <DllImport("axpad02.dll")> _
    Public Shared Function Ad02OutPort(ByVal wLogSocket As Short, ByVal bValue As Byte) As Boolean
    End Function
    <DllImport("axpad02.dll")> _
    Public Shared Function Ad02SingleSampling(ByVal wLogSocket As Short, ByVal dwCh As Integer, ByVal dwVoltageRange As Integer, ByRef pwData As Short) As Boolean
    End Function

    '*****************************************************************************
    '*    AXP-AD02 DLL,Driver̃o[Wԍ擾                            *
    '*    pdwDllVer DLLo[Wԍi[                                  *
    '*        pdwDrvVer Drivero[Wԍi[                               *
    '* ߂l  True                                                          *
    '*        s False                                                         *
    '*****************************************************************************
    Public Function GetVersion(ByRef pdwDllVer As Integer, ByRef pdwDrvVer As Integer) As Boolean
        Try
            GetVersion = Ad02GetVersion(pdwDllVer, pdwDrvVer)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "AXP-AD02 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            GetVersion = False
        End Try
    End Function
    '*****************************************************************************
    '*    AXP-AD02̔Cӂ̃foCX̎gp錾                               *
    '*    pwLogSocket gpfoCXi[AhX                     *
    '*        hWnd      bZ[W𑗂EBhEnh                       *
    '*        uWMBase   ƂȂ郁bZ[WID                                   *
    '*        pvInitArg gp(0Zbg)                                        *
    '* ߂l  True                                                          *
    '*        s False                                                         *
    '*****************************************************************************
    Public Function Create(ByRef pwLogSocket As Short, ByVal hWnd As Integer, ByVal uWMBase As Short, ByRef pvInitArg As Integer) As Boolean
        Try
            Create = Ad02Create(pwLogSocket, hWnd, uWMBase, pvInitArg)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "AXP-AD02 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            Create = False
        End Try
    End Function
    '*****************************************************************************
    '*    AXP-AD02̔Cӂ̃foCX̎gpJ                               *
    '*    wLogSocket gpfoCX                                        *
    '* ߂l  True                                                          *
    '*        s False                                                         *
    '*****************************************************************************
    Public Function Close(ByVal wLogSocket As Short) As Boolean
        Try
            Close = Ad02Close(wLogSocket)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "AXP-AD02 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            Close = False
        End Try
    End Function
    '*****************************************************************************
    '*    wfoCX̃\[X擾                                   *
    '*    wLogSocket ׂfoCX                                          *
    '*        pres     \[Xi[\                              *
    '* ߂l  True                                                          *
    '*        s False                                                         *
    '*****************************************************************************
    Public Function GetResource(ByVal wLogSocket As Short, ByRef pres As Resource) As Boolean
        Try
            GetResource = Ad02GetResource(wLogSocket, pres)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "AXP-AD02 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            GetResource = False
        End Try
    End Function
    '*****************************************************************************
    '*    TvO[h̐ݒ                                           *
    '*    wLogSocket ݒ肷foCX                                        *
    '*        pmode    [hݒf[^̃AhX                                *
    '* ߂l  True                                                          *
    '*        s False                                                         *
    '*****************************************************************************
    Public Function SetMode(ByVal wLogSocket As Short, ByRef pmode As Mode) As Boolean
        Try
            SetMode = Ad02SetMode(wLogSocket, pmode)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "AXP-AD02 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            SetMode = False
        End Try
    End Function
    '*****************************************************************************
    '*    TvOJn                                                   *
    '*    wLogSocket JnfoCX                                        *
    '* ߂l  True                                                          *
    '*        s False                                                         *
    '*****************************************************************************
    Public Function StartSampling(ByVal wLogSocket As Short) As Boolean
        Try
            StartSampling = Ad02StartSampling(wLogSocket)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "AXP-AD02 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            StartSampling = False
        End Try
    End Function
    '*****************************************************************************
    '*    TvO~                                                   *
    '*    wLogSocket ~foCX                                        *
    '* ߂l  True                                                          *
    '*        s False                                                         *
    '*****************************************************************************
    Public Function StopSampling(ByVal wLogSocket As Short) As Boolean
        Try
            StopSampling = Ad02StopSampling(wLogSocket)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "AXP-AD02 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            StopSampling = False
        End Try
    End Function
    '*****************************************************************************
    '*    TvOEXe[^X̎擾                                     *
    '*    wLogSocket   擾foCX                                      *
    '*        pcwData f[^obt@                                           *
    '*        pdwStatus  Xe[^X                                              *
    '* ߂l  True                                                          *
    '*        s False                                                         *
    '*****************************************************************************
    Public Function GetSamplingStatus(ByVal wLogSocket As Short, ByRef pcwData As Integer, ByRef pdwStatus As Integer) As Boolean
        Try
            GetSamplingStatus = Ad02GetSamplingStatus(wLogSocket, pcwData, pdwStatus)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "AXP-AD02 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            GetSamplingStatus = False
        End Try
    End Function
    '*****************************************************************************
    '*    TvOς݃f[^̎擾                                       *
    '*    wLogSocket  擾foCX                                       *
    '*        pwData    f[^obt@                                           *
    '*        cwData    ǂݏof[^                                         *
    '* ߂l  True                                                          *
    '*        s False                                                         *
    '*****************************************************************************
    Public Function GetData(ByVal wLogSocket As Short, ByRef pwData As Short, ByVal cwData As Integer) As Boolean
        Try
            GetData = Ad02GetData(wLogSocket, pwData, cwData)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "AXP-AD02 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            GetData = False
        End Try
    End Function
    '*****************************************************************************
    '*    ėp͂̒l擾                                                 *
    '*    wLogSocket  擾foCX                                       *
    '*        bpValue     li[ꏊ̃AhX                             *
    '* ߂l  True                                                          *
    '*        s False                                                         *
    '*****************************************************************************
    Public Function InPort(ByVal wLogSocket As Short, ByRef pbValue As Byte) As Boolean
        Try
            InPort = Ad02InPort(wLogSocket, pbValue)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "AXP-AD02 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            InPort = False
        End Try
    End Function
    '*****************************************************************************
    '*    ėpo̓|[gɒlo                                           *
    '*    wLogSocket  擾foCX                                       *
    '*        pValue      o͂l                                             *
    '* ߂l  True                                                          *
    '*        s False                                                         *
    '*****************************************************************************
    Public Function OutPort(ByVal wLogSocket As Short, ByVal bValue As Byte) As Boolean
        Try
            OutPort = Ad02OutPort(wLogSocket, bValue)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "AXP-AD02 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            OutPort = False
        End Try
    End Function
    '*****************************************************************************
    '*    VOTvOf[^擾                                     *
    '*    wLogSocket     擾foCX                                    *
    '*        dwCh           Ώۃ`l                                      *
    '*        dwVoltageRange dW                                          *
    '*        pwData         TvOς݃f[^i[̈                *
    '* ߂l  True                                                          *
    '*        s False                                                         *
    '*****************************************************************************
    Public Function SingleSampling(ByVal wLogSocket As Short, ByVal dwCh As Integer, ByVal dwVoltageRange As Integer, ByRef pwData As Short) As Boolean
        Try
            SingleSampling = Ad02SingleSampling(wLogSocket, dwCh, dwVoltageRange, pwData)
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "AXP-AD02 Error")
            mErrWradll = ERR_WRAPDLL    ' bp[֐G[
            SingleSampling = False
        End Try
    End Function
    '*****************************************************************************
    '*    AXP-AD02̃G[R[h                                             *
    '*    wLogSocket  G[foCX                               *
    '* ߂l G[R[h                                                       *
    '*****************************************************************************
    Function GetLastError(ByVal wLogSocket As Short) As Integer
        Try
            If mErrWradll = ERR_WRAPDLL Then    ' bp[֐G[Ȃ
                mErrWradll = SUCCESS            ' NA
                GetLastError = ERR_WRAPDLL
            Else
                GetLastError = Ad02GetLastError(wLogSocket)
            End If
        Catch e As Exception
            MsgBox(e.Message, MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "AXP-AD02 Error")
            GetLastError = ERR_WRAPDLL
            mErrWradll = SUCCESS            ' NA
        End Try
    End Function

End Class
