/*****************************************************************************
 * axpad02w.h
 *
 * AXP-AD02
 * Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
 *****************************************************************************/
#ifndef __AXPAD02__
#define __AXPAD02__

#include "axpad02.h"

#ifdef __cplusplus
extern "C"{
#endif

#define AD02_DLL_NAME	  	_T("axpad02.dll")	// DLL
#define AD02_ERR_WRAPDLL 	((DWORD)-1)			// bp[֐G[

// DLL [h
BOOL Ad02wDllOpen ( void );

// DLL A[h
BOOL Ad02wDllClose ( void );

// AXP-AD02 DLL,Driver̃o[Wԍ擾
BOOL Ad02wGetVersion ( PDWORD pdwDllVer, PDWORD pdwDrvVer );

// CӂAXP-AD02̎gp錾
BOOL Ad02wCreate(PWORD pwLogSocket, HWND hWnd, UINT uWMBase, PVOID pvInitArg );

// CӂAXP-AD02̎gpJ
BOOL Ad02wClose ( WORD wLogSocket );

// \[X擾
BOOL Ad02wGetResource ( WORD wLogSocket, PAD02R pResInfo );

// TvO샂[hݒ
BOOL Ad02wSetMode (WORD wLogSocket, PCAD02M pmode);

// TvOJn
BOOL Ad02wStartSampling (WORD wLogSocket);

// TvO~
BOOL Ad02wStopSampling (WORD wLogSocket);

// TvOԂ̎擾
BOOL Ad02wGetSamplingStatus (WORD wLogSocket, PDWORD pcwData, PDWORD pdwStatus);

// TvOς݃f[^̎擾
BOOL Ad02wGetData (WORD wLogSocket, PWORD pwData, DWORD cwData);

// ėpo̓|[gɒlo
BOOL Ad02wOutPort (WORD wLogSocket, BYTE bValue );

// ėp̓|[g̒l擾
BOOL Ad02wInPort (WORD wLogSocket, PBYTE pbValue );

// VOTvOf[^擾
BOOL Ad02wSingleSampling(WORD wLogSocket, DWORD dwCh, DWORD dwVoltageRange, PWORD pwData );

// G[R[h擾
DWORD Ad02wGetLastError( WORD wLogSocket ); 

#ifdef __cplusplus
}
#endif
#endif // __AXPAD02__
