Attribute VB_Name = "DLLDef"
'-----------------------------------------------------------------
' axpad02.bas
' AXP-AD02 Win32 API.
'
' Copyright(C)ADTEK SYSTEM SCIECEN Co.,Ltd.
'-----------------------------------------------------------------

Option Explicit
'-----------------------------------------------------------------
' G[R[h
'-----------------------------------------------------------------
Global Const AD02_SUCCESS = 0               ' ُȂiIj
Global Const AD02_ERR_SYSTEM = 1            ' ɃhCo[hĂȂ\܂
Global Const AD02_ERR_NO_DEVICE = 2         ' gp\ȃfoCX܂
Global Const AD02_ERR_NOT_CREATED = 3       ' w̃foCX͎gp錾Ă܂
Global Const AD02_ERR_IN_USE = 4            ' w̃foCX͑̃vZXŎgpł
Global Const AD02_ERR_INVALID_SOCKET = 5    ' Ș_\Pbgԍł
Global Const AD02_ERR_RESOURCE = 6          ' \[XG[
Global Const AD02_ERR_INVALID_ARGUMENT = 7  ' sȈw肵܂
Global Const AD02_ERR_VOLTAGE_RANGE = 8     ' sȓdlw肵܂
Global Const AD02_ERR_CHANNEL = 9           ' sȃ`lw肵܂
Global Const AD02_ERR_TIMER = 10            ' sȃ^C}w肵܂
Global Const AD02_ERR_TRIG_SOURCE = 11      ' sȃgKw肵܂
Global Const AD02_ERR_SAMPLE_MODE = 12      ' sȃ[hw肵܂
Global Const AD02_ERR_NOT_ENOUGH_MEM = 13   ' w肳ꂽobt@mۂł܂ł
Global Const AD02_ERR_NO_DATA = 14          ' f[^v܂
Global Const AD02_ERR_NO_SETMODE = 20       ' [hݒ肳Ă܂ł
Global Const AD02_ERR_BUSY = 21             ' TvO쒆ł
'-----------------------------------------------------------------
' ̑̒萔
'-----------------------------------------------------------------
Global Const AD02_SOCKET_AUTO = &HFFFF
Global Const AD02_MAX_SOCKETS = 4           ' foCX͂S܂Ŏg܂
Global Const AD02_NUM_CHANNELS = 8
'-----------------------------------------------------------------
' dW
'-----------------------------------------------------------------
Global Const AD02_VR_S10V = 0               ' +-10V range
Global Const AD02_VR_S5V = 1                ' +- 5V range
'-----------------------------------------------------------------
' gK
'-----------------------------------------------------------------
Global Const AD02_TS_INTERNAL = 0           ' gKgp
Global Const AD02_TS_EXTERNAL = 1           ' OgKgp
'-----------------------------------------------------------------
' TvO
'-----------------------------------------------------------------
Global Const AD02_SM_ONESHOT = 0            ' Vbg
Global Const AD02_SM_CONTINUOUS = 1         ' ATvO
'-----------------------------------------------------------------
' TvOXe[^X̃rbg}XN
'-----------------------------------------------------------------
Global Const AD02_BMSST_BUSY = &H1          ' Busy
Global Const AD02_BMSST_EOC = &H2           ' Not busy
Global Const AD02_BMSST_HALF_FULL = &H4     ' Ring buffer half full
Global Const AD02_BMSST_OVERFLOW = &H8      ' Ring buffer overflow
Global Const AD02_BMSST_OVERRUN = &H10      ' FIFO overrun
'-----------------------------------------------------------------
' hCo瑗Ă郁bZ[W
' ̒l uWMBase𑫂lĂ܂
'-----------------------------------------------------------------
Global Const AD02_WM_OFS_CARD_REMOVAL = 0
Global Const AD02_WM_OFS_EOC = 1
Global Const AD02_WM_OFS_HALF_FULL = 2
Global Const AD02_WM_OFS_OVERFLOW = 3
Global Const AD02_WM_OFS_OVERRUN = 4
Global Const AD02_WM_OFS_EXIN = 5
'-----------------------------------------------------------------
' \[X\̊evf̍ő吔
'-----------------------------------------------------------------
Global Const AD02_MAX_MEM = 9
Global Const AD02_MAX_IO = 20
Global Const AD02_MAX_IRQ = 7
Global Const AD02_MAX_DMA = 7
'-----------------------------------------------------------------
' \[X\
'-----------------------------------------------------------------
Type AD02_RESOURCE
    dwNumMemWindows As Long                     ' EBhE
    dwMemBase(1 To AD02_MAX_MEM) As Long        ' EBhEJnAhX
    dwMemLength(1 To AD02_MAX_MEM) As Long      ' EBhE
    dwMemAttrib(1 To AD02_MAX_MEM) As Long      ' EBhE
    dwNumIOPorts As Long                        ' I/O|[g
    dwIOPortBase(1 To AD02_MAX_IO) As Long      ' I/O|[gJnAhX
    dwIOPortLength(1 To AD02_MAX_IO) As Long    ' I/O|[g
    dwNumIRQs As Long                           ' IRQ
    dwIRQRegisters(1 To AD02_MAX_IRQ) As Long   ' IRQԍ
    dwIRQAttrib(1 To AD02_MAX_IRQ) As Long      ' IRQ
    dwNumDMAs As Long                           ' DMA`l
    dwDMALst(1 To AD02_MAX_DMA) As Long         ' DMA`l
    dwDMAAttrib(1 To AD02_MAX_DMA) As Long      ' DMA`l
    dwReserved1(1 To 3) As Long                 ' \
End Type
'-----------------------------------------------------------------
' 샂[hݒ\
'-----------------------------------------------------------------
Type AD02_MODE
    dwVoltageRange As Long                      ' dW
    dwChFirst As Long                           ' Jn`l
    dwChLast As Long                            ' ŏI`l
    dwTimer As Long                             ' ^C}
    dwTrigSource As Long                        ' gK\[X
    dwSampleMode As Long                        ' TvO[h
    cwBuffer As Long                            ' obt@TCY
End Type
'-----------------------------------------------------------------
' API Functions
'-----------------------------------------------------------------
Public Declare Function Ad02GetVersion Lib "axpad02" (ByRef pdwDllVer As Long, ByRef pdwDrvVer As Long) As Long
Public Declare Function Ad02Create Lib "axpad02" (ByRef pwLogSocket As Integer, ByVal hWnd As Long, ByVal uWMBase As Long, ByRef pvInitArg As Any) As Long
Public Declare Function Ad02Close Lib "axpad02" (ByVal wLogSocket As Integer) As Long
Public Declare Function Ad02GetResource Lib "axpad02" (ByVal wLogSocket As Integer, ByRef pres As AD02_RESOURCE) As Long
Public Declare Function Ad02SetMode Lib "axpad02" (ByVal wLogSocket As Integer, ByRef pmode As AD02_MODE) As Long
Public Declare Function Ad02StartSampling Lib "axpad02" (ByVal wLogSocket As Integer) As Long
Public Declare Function Ad02StopSampling Lib "axpad02" (ByVal wLogSocket As Integer) As Long
Public Declare Function Ad02GetSamplingStatus Lib "axpad02" (ByVal wLogSocket As Integer, ByRef pcwData As Long, ByRef pdwStatus As Long) As Long
Public Declare Function Ad02GetData Lib "axpad02" (ByVal wLogSocket As Integer, ByRef pwData As Integer, ByVal cwData As Long) As Long
Public Declare Function Ad02GetLastError Lib "axpad02" (ByVal wLogSocket As Integer) As Long
Public Declare Function Ad02InPort Lib "axpad02" (ByVal wLogSocket As Integer, ByRef pbValue As Byte) As Long
Public Declare Function Ad02OutPort Lib "axpad02" (ByVal wLogSocket As Integer, ByVal bValue As Byte) As Long
Public Declare Function Ad02SingleSampling Lib "axpad02" (ByVal wLogSocket As Integer, ByVal dwCh As Long, ByVal dwVoltageRange As Long, ByRef pwData As Integer) As Long







